@echo on

mkdir C:\windows\log
echo [%date% %time%] M BIOS AsMedia start  >> C:\windows\log\AsMUpdate.txt

:Job
REM ====================================================================================================
set BiosRomVersion=0
set InfName=Skip_0.inf
REM ====================================================================================================

set reboot=0

reg delete HKEY_LOCAL_MACHINE\SOFTWARE\ASUS\BIOS /v Uptodate /f


for /f "tokens=2 delims==" %%f in ('wmic bios get smbiosbiosversion /value ^| find "="') do set "BIOSVersion=%%f"

for /F "tokens=1* delims=." %%G in ("%BIOSVersion%") DO set "BiosCurVersion=%%H"

echo BiosRomVersion %BiosRomVersion%
echo BiosCurVersion %BiosCurVersion%

:: Force flash BIOS if current BIOS is test version
echo %BiosCurVersion%| findstr /r "^[0-9][0-9]*$">nul

if %errorlevel% neq 0 (
    echo Invalid number
    goto flashBIOS
)

if %BiosCurVersion% GEQ %BiosRomVersion% (
  echo BIOS uptodate
  goto checkVM
) else (
  goto flashBIOS
)

:flashBIOS
echo flash BIOS

pushd %~dp0
pnputil -i -a %InfName%

set reboot=1


:checkVM
echo check VM

rd /S /Q "C:\windows\log\ALU\"

mkdir C:\windows\log\ALU\

dism /online /get-features /English > C:\windows\log\ALU\features.log


dism /online /get-featureinfo /featurename:HypervisorPlatform /English | findstr State > C:\windows\log\ALU\HypervisorPlatform.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\HypervisorPlatform.log
if %errorlevel% == 0 (
  echo HypervisorPlatform disabled
) else (
  echo HypervisorPlatform enabled
  dism /online /disable-feature /featurename:HypervisorPlatform /norestart
  set reboot=1
)

dism /online /get-featureinfo /featurename:VirtualMachinePlatform /English | findstr State > C:\windows\log\ALU\VirtualMachinePlatform.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\VirtualMachinePlatform.log
if %errorlevel% == 0 (
  echo VirtualMachinePlatform disabled
) else (
  echo VirtualMachinePlatform enabled
  dism /online /disable-feature /featurename:VirtualMachinePlatform /norestart
  set reboot=1
)

dism /online /get-featureinfo /featurename:Microsoft-Hyper-V-All /English | findstr State > C:\windows\log\ALU\Microsoft-Hyper-V-All.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Microsoft-Hyper-V-All.log
if %errorlevel% == 0 (
  echo Microsoft-Hyper-V-All disabled
) else (
  echo Microsoft-Hyper-V-All enabled
  dism /online /disable-feature /featurename:Microsoft-Hyper-V-All /norestart
  set reboot=1
)

dism /online /get-featureinfo /featurename:Microsoft-Hyper-V /English | findstr State > C:\windows\log\ALU\Microsoft-Hyper-V.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Microsoft-Hyper-V.log
if %errorlevel% == 0 (
  echo Microsoft-Hyper-V disabled
) else (
  echo Microsoft-Hyper-V enabled
  dism /online /disable-feature /featurename:Microsoft-Hyper-V /norestart
  set reboot=1
)


dism /online /get-featureinfo /featurename:Microsoft-Hyper-V-Tools-All /English | findstr State > C:\windows\log\ALU\Microsoft-Hyper-V-Tools-All.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Microsoft-Hyper-V-Tools-All.log
if %errorlevel% == 0 (
  echo Microsoft-Hyper-V-Tools-All disabled
) else (
  echo Microsoft-Hyper-V-Tools-All enabled
  dism /online /disable-feature /featurename:Microsoft-Hyper-V-Tools-All /norestart
  set reboot=1
)

dism /online /get-featureinfo /featurename:Microsoft-Hyper-V-Management-PowerShell /English | findstr State > C:\windows\log\ALU\Microsoft-Hyper-V-Management-PowerShell.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Microsoft-Hyper-V-Management-PowerShell.log
if %errorlevel% == 0 (
  echo Microsoft-Hyper-V-Management-PowerShell disabled
) else (
  echo Microsoft-Hyper-V-Management-PowerShell enabled
  dism /online /disable-feature /featurename:Microsoft-Hyper-V-Management-PowerShell /norestart
  set reboot=1
)


dism /online /get-featureinfo /featurename:Microsoft-Hyper-V-Hypervisor /English | findstr State > C:\windows\log\ALU\Microsoft-Hyper-V-Hypervisor.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Microsoft-Hyper-V-Hypervisor.log
if %errorlevel% == 0 (
  echo Microsoft-Hyper-V-Hypervisor disabled
) else (
  echo Microsoft-Hyper-V-Hypervisor enabled
  dism /online /disable-feature /featurename:Microsoft-Hyper-V-Hypervisor /norestart
  set reboot=1
)


dism /online /get-featureinfo /featurename:Microsoft-Hyper-V-Services /English | findstr State > C:\windows\log\ALU\Microsoft-Hyper-V-Services.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Microsoft-Hyper-V-Services.log
if %errorlevel% == 0 (
  echo Microsoft-Hyper-V-Services disabled
) else (
  echo Microsoft-Hyper-V-Services enabled
  dism /online /disable-feature /featurename:Microsoft-Hyper-V-Services /norestart
  set reboot=1
)


dism /online /get-featureinfo /featurename:Microsoft-Hyper-V-Management-Clients /English | findstr State > C:\windows\log\ALU\Microsoft-Hyper-V-Management-Clients.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Microsoft-Hyper-V-Management-Clients.log
if %errorlevel% == 0 (
  echo Microsoft-Hyper-V-Management-Clients disabled
) else (
  echo Microsoft-Hyper-V-Management-Clients enabled
  dism /online /disable-feature /featurename:Microsoft-Hyper-V-Management-Clients /norestart
  set reboot=1
)

dism /online /get-featureinfo /featurename:HostGuardian /English | findstr State > C:\windows\log\ALU\HostGuardian.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\HostGuardian.log
if %errorlevel% == 0 (
  echo HostGuardian disabled
) else (
  echo HostGuardian enabled
  dism /online /disable-feature /featurename:HostGuardian /norestart
  set reboot=1
)

dism /online /get-featureinfo /featurename:Containers-DisposableClientVM /English | findstr State > C:\windows\log\ALU\Containers-DisposableClientVM.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Containers-DisposableClientVM.log
if %errorlevel% == 0 (
  echo Containers-DisposableClientVM disabled
) else (
  echo Containers-DisposableClientVM enabled
  dism /online /disable-feature /featurename:Containers-DisposableClientVM /norestart
  set reboot=1
)

dism /online /get-featureinfo /featurename:Microsoft-Windows-Subsystem-Linux /English | findstr State > C:\windows\log\ALU\Microsoft-Windows-Subsystem-Linux.log
findstr /n /i /p /c:"disable" C:\windows\log\ALU\Microsoft-Windows-Subsystem-Linux.log
if %errorlevel% == 0 (
  echo Microsoft-Windows-Subsystem-Linux disabled
) else (
  echo Microsoft-Windows-Subsystem-Linux enabled
  dism /online /disable-feature /featurename:Microsoft-Windows-Subsystem-Linux /norestart
  set reboot=1
)

 
set VALUE=NULL
set KEY="HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\DeviceGuard\Scenarios\HypervisorEnforcedCodeIntegrity"
set NAME=Enabled

FOR /F "tokens=2* skip=2" %%a in ('reg query %KEY% /v %NAME% 2^>nul') do set VALUE=%%b

if "%VALUE%"=="0x1" (
 echo Enabled > C:\windows\log\ALU\MemoryIntegrity.log
 echo MemoryIntegrity on
 reg add "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\DeviceGuard\Scenarios\HypervisorEnforcedCodeIntegrity" /v Enabled /t REG_DWORD /d 0 /f
 set reboot=1
) else (
 echo Disabled > C:\windows\log\ALU\MemoryIntegrity.log
 echo MemoryIntegrity off

)



if %reboot% EQU 0 (
  reg add "HKEY_LOCAL_MACHINE\SOFTWARE\ASUS\BIOS" /v Uptodate /t REG_DWORD /d 1 /f
)


goto :eof
